/*
 * Copyright (c) 2022, Technische Universität Kaiserslautern
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * Authors:
 *    Iron Prando da Silva
 */

#include "poolcontrollermap.h"

PoolControllerMap::PoolControllerMap(const std::map<StringMapper, PoolController>& pools) {
    mPools = pools;
}

void PoolControllerMap::clear() {
    for (auto& p : mPools) {
        p.second.clear();
    }

}

void PoolControllerMap::push(const StringMapper& poolName, DBDependencyEntry dep) {
    auto pool = mPools.find(poolName);
    if (pool != mPools.end()) {
        pool->second.push(dep);

    } else {
        // TODO throw?
    }
}

void PoolControllerMap::increment(const StringMapper& poolName) {
    auto pool = mPools.find(poolName);
    if (pool != mPools.end()) {
        pool->second.increment();

    } else {
        // TODO throw?
    }
}

void PoolControllerMap::merge(std::vector<DBDependencyEntry>& depEntries) {
    for (auto& p : mPools) {
        p.second.merge(depEntries);
    }
}

uint PoolControllerMap::getBusyTime(const StringMapper& poolName, const StringMapper& phaseName) {
    auto pool = mPools.find(poolName);
    if (pool != mPools.end()) {
        return pool->second.getBusyTime(phaseName);

    } else {
        // TODO throw?
        return 0;
    
    }
}

size_t PoolControllerMap::count(const StringMapper& poolName) {
    auto pool = mPools.find(poolName);
    if (pool != mPools.end()) {
        return pool->second.count();

    } else {
        // TODO throw?
        return 0;
    
    }
}
